<%@ Register TagPrefix="wi" TagName="Layout" Src="include/layout.ascx" %>
<%
// login.aspx
// Copyright (c) 2002 - 2005 Citrix Systems, Inc. All Rights Reserved.
// Web Interface (Build 45083)
%>

<%@ Import namespace="com.citrix.wi.ui" %>
<%@ Import namespace="com.citrix.authentication.tokens" %>
<%@ Import namespace="com.swivelsecure.pinsafe" %>

<!--#include file="serverscripts/webinterface.cs"-->
<!--#include file="serverscripts/include.cs"-->
<!--#include file="serverscripts/login.cs"-->
<!--#include file="serverscripts/loginNDS.cs"-->

<script runat="server">
    LoginPageControl viewControl = new LoginPageControl();
    ToolbarControl toolbarControl = new ToolbarControl();
    WelcomeControl welcomeControl = new WelcomeControl();

    void Page_Load(object sender, System.EventArgs e) {
        Context.Items.Add( "viewControl", viewControl );
        Context.Items.Add( "toolbarControl", toolbarControl );
        Context.Items.Add( "welcomeControl", welcomeControl );

        layout.PageClientScript = "../clientscripts/loginClientScript.ascx";
        layout.PageView = "loginView.ascx";
    }

    UserEnvironmentAdaptor envAdaptor = null;
</script>

<%
if ( Request.HttpMethod == "GET" && clientDetectionRequired() ) {
%>
<!--#include file="include/clientdetect.inc" -->
<%
} else {

    envAdaptor = getUserEnvAdaptor();

    AuthenticationConfiguration authConfig = getAuthenticationConfiguration();

    if ( Request.HttpMethod == "GET" ) {
        // This may or may not return
        if ( Request.QueryString[QSTR_LOGINTYPE] != null ) {
            // Login data is given in the URL. Attempt to use it. We will fall
            // through if the data is not a valid login attempt.
            loginHandleLoginRequest( Request.QueryString[QSTR_LOGINTYPE] );
        } else if (!equalsIgnoreCase(VAL_OFF, (string) getUserEnvAdaptor().getClientSessionState().get(COOKIE_ALLOW_SILENT)) ) {
            // Attempt to perform silent authentication, unless its been switched off for this session
            loginProcessDirectLogin();
        }
    }

    // If we've marked the browser session to indicate login has been started,
    // but we've ended up back at the login page the session has been terminated
    // for some reason.  The comes after checking for URL login requests because
    // Certificate authentication may need to come through that route.
    string sLogonMode = authGetUntrustedLogonType();
    if ((sLogonMode != null) && (sLogonMode.Trim() != "")) {
        HandleLogoutMessage(MSG_INFO, "SessionExpired");
    }

    if (Request.HttpMethod == "POST") {
        // This may or may not return
        loginProcessPost();
    }

    //
    // From here on in, setup the view controls, etc used to control the
    // page rendering.  Business logic is above.  Note business logic may
    // have modified viewControl, etc already.
    //

    // Get the updated locale from the user preferences as it may have been updated
    // in advanced options
    currentLocale = getCurrentLocale( userPrefs );

    // Configure the layout control.
    layout.PageTitle = getString("LoginTitle", currentLocale);

    // Prepare toolbar and welcome message controls with default values
    toolbarControl.setTitle( getString("NFuseLogin", currentLocale) );
    toolbarControl.setHelpLocation( "Login" );
    welcomeControl.setTitle( getString("PleaseLogin", currentLocale) );
    welcomeControl.setBody( getString("PleaseLogin3", currentLocale) );

    // Check whether 2-factor authentication is enabled
    viewControl.setShowPasscode( getTwoFactorAuthMethod() != null );

    // Check whether to show login type options
    ExplicitAuth expAuth = (ExplicitAuth)authConfig.getMethod( AuthMethod.EXPLICIT );
    bool onlyExplicitAllowed = ( ( loginTypeCount( sClientInfo.isIE() ) == 1 ) && (expAuth != null ) );
    bool noOptionsAllowed = ( loginTypeCount( sClientInfo.isIE() ) == 0 );
    viewControl.setShowLoginTypeOptions( !( onlyExplicitAllowed || noOptionsAllowed ) );
    viewControl.setAllUIDisabled( noOptionsAllowed );
    if( noOptionsAllowed ) {
        messageCenterControl.setType( MessageCenterControl.MSGTYPE_ERROR );
        messageCenterControl.setKey( "NoAuthenticationMethods" );
    }

    // If we arrive here via an error set the error message in the Message Center.
    setMessageFromQueryString();

    string logonMode = loginGetDefaultLoginType( userPrefs.getAuthMethod() );
    viewControl.setSelectedLogonMode( logonMode );

    // If logon mode is not explicit, disable the UPD entries.
    if (logonMode != AuthMethod.EXPLICIT) {
        viewControl.setExplicitDisabled(true);
        viewControl.setDomainDisabled(true);
    }

    // Check explicit login settings
    if (expAuth != null) {
        // Check whether it is NDS login
        if (expAuth is ExplicitNDSAuth) {
            ExplicitNDSAuth ndsAuth = (ExplicitNDSAuth)expAuth;
            viewControl.setNDSEnabled( true );
            viewControl.setNDSTree( ndsAuth.getTreeName() );
            viewControl.setShowFindContext( !ndsAuth.getServerList().isEmpty() );

            // If user has a context stored in a password, verify that it is allowed
            // and then set it as the selected menu item
            string lastContext = (string)getUserEnvAdaptor().getUserState().get(COOKIE_NDS_CONTEXT);
            if (lastContext != null && viewControl.getNDSContexts() != null &&
                viewControl.getNDSContexts().Length < 1) {
                if (ndsAuth.getContextList().isEmpty() || ndsAuth.isValidContext(lastContext)) {
                    viewControl.setNDSContexts(new string[] {lastContext});
                }
            }
        } else {
            // Not NDS
            ExplicitUDPAuth udpAuth = (ExplicitUDPAuth)expAuth;
            int numDomains = udpAuth.getDomains().size();

            // Hide the domain field only if this has been configured and:
            //     there is at most one entry in the list of domains, or
            //     login is restricted to the entries in the list of domains
            bool hideDomain = udpAuth.getDomainFieldHidden() &&
                ( ( numDomains <= 1 ) || udpAuth.getDomainsRestricted() );
            viewControl.setShowDomain( !hideDomain );

            if ( numDomains != 0 ) {
                viewControl.setLoginDomains( udpAuth.getDomainsArray() );
            }
            viewControl.setRestrictDomains( udpAuth.getDomainsRestricted() );

            // don't show the password field if the 2-factor Password integration
            // facility is configured.
            viewControl.setShowPassword(! (isPasswordIntegrationEnabled()) );
        }

        // Set the welcome message according to the situation
        if (loginTypeCount( sClientInfo.isIE()) == 1 ) {
            welcomeControl.setBody( getString("PleaseLogin4", currentLocale) );
        } else {
            welcomeControl.setBody( getString("PleaseLogin5", currentLocale) );
        }
    } else {
        viewControl.setShowDomain( true );
    }

    // Whether to show advanced options permanently.
    viewControl.setShowAdvancedOptionsPermanently( sClientInfo.osPocketPC() );

    // Whether to open advanced options.
    viewControl.setAdvancedOptionsOpened( equalsIgnoreCase(VAL_TRUE, (string) getNonEncodedCookie(COOKIE_ADV_OPTIONS_OPENED)) );

    // Whether to show client type.
    ClientDeploymentConfiguration cdConfig = getClientDeploymentConfiguration();
    bool bShowClientTypeOptions = cdConfig.getAllowCustomizeClients() && (! sClientInfo.isSafari()) && (! sClientInfo.osPocketPC());
    viewControl.setShowClientTypeOptions( bShowClientTypeOptions );

    if (bShowClientTypeOptions) {
        // Determines what clients are shown in the dropdown box.
        if (cdConfig.isEnabledClient(MPSClientType.LOCAL_ICA)) {
            viewControl.setShowClientTypeICALocal( true );
        }
        if (cdConfig.isEnabledClient(MPSClientType.EMBEDDED_ICA)) {
            viewControl.setShowClientTypeICAEmbedded((sClientInfo.osWin32() &&
                (sClientInfo.isIE() || sClientInfo.isNetscape())) ||
                (sClientInfo.osWinCE() && (! sClientInfo.osPocketPC()) && sClientInfo.isIE()));
        }

        if (cdConfig.isEnabledClient(MPSClientType.JAVA)) {
            viewControl.setShowClientTypeICAJava(! sClientInfo.osWinCE());
        }

        if (cdConfig.isEnabledClient(MPSClientType.EMBEDDED_RDP)) {
            viewControl.setShowClientTypeRDPEmbedded(sClientInfo.osWin32() && sClientInfo.isIE());
        }

        // Determines what client is selected.
        viewControl.setSelectedClientType( getSelectedClient() );
    }

    // Bandwidth control selection box
    ClientConnectionConfiguration connConfig = getClientConnectionConfiguration();
    viewControl.setShowBandwidthOptions( connConfig.getAllowCustomizeBandwidth() );
    viewControl.setSelectedBandwidth( userPrefs.getBandwidth() );
    viewControl.setShowBandwidthCustom( connConfig.getAllowCustomizeAudio()
            || connConfig.getAllowCustomizeWinColor()
            || connConfig.getAllowCustomizePrinterMapping() );

    // Reconnect at login box
    WorkspaceControlConfiguration wscConfig = getWorkspaceControlConfiguration();
    bool bShowReconnectOptions = wscConfig.getAllowCustomizeReconnectAtLogin() &&
            (workspaceControl != RC_DISABLED)
            && ((getSelectedClient() != MPSClientType.EMBEDDED_RDP)
                    || getClientDeploymentConfiguration().getAllowCustomizeClients());
    viewControl.setShowReconnectOptions( bShowReconnectOptions );
    if (bShowReconnectOptions) {
        bool bReconnectOptionDisabled = (logonMode == AuthMethod.ANONYMOUS) ||
                (getSelectedClient() == MPSClientType.EMBEDDED_RDP) ||
                ((workspaceControl == RC_JAVACLIENT_ONLY)
                && (getSelectedClient() != MPSClientType.JAVA));

        viewControl.setReconnectOptionsDisabled( bReconnectOptionDisabled );

        ReconnectOption reconnectOption = bReconnectOptionDisabled ? ReconnectOption.NONE :
            userPrefs.getReconnectAtLoginAction();
        viewControl.setReconnectAtLogin( reconnectOption );
    }

    // Language selection box
    LanguageManager langmgr = getLanguageManager();
    LanguagePack[] packs = langmgr.getLanguagePacks();
    viewControl.setShowLanguageOptions( packs.Length > 1 );
    viewControl.setLanguages( packs );
    viewControl.setSelectedLanguage( langmgr.getLanguagePack( currentLocale ) );

    // Determine the allowed login modes
    if ( authConfig.isEnabledMethod( AuthMethod.ANONYMOUS) ) {
        viewControl.allowedLogonModes().add( AuthMethod.ANONYMOUS );
    }
    if (sClientInfo.isIE()) {
        if ( authConfig.isEnabledMethod( AuthMethod.CERTIFICATE_SINGLE_SIGN_ON ) ) {
            viewControl.allowedLogonModes().add( AuthMethod.CERTIFICATE_SINGLE_SIGN_ON );
        }
        if ( authConfig.isEnabledMethod( AuthMethod.CERTIFICATE ) ) {
            viewControl.allowedLogonModes().add( AuthMethod.CERTIFICATE );
        }
        if ( authConfig.isEnabledMethod( AuthMethod.SINGLE_SIGN_ON ) ) {
            viewControl.allowedLogonModes().add( AuthMethod.SINGLE_SIGN_ON );
        }
    }
    if ( authConfig.isEnabledMethod( AuthMethod.EXPLICIT ) ) {
        viewControl.allowedLogonModes().add( AuthMethod.EXPLICIT );
    }

    string sSMCLoggedOut = (string) envAdaptor.getClientSessionState().get(COOKIE_SMC_LOGGED_OUT);
    if (equalsIgnoreCase(sSMCLoggedOut, VAL_ON)) {
        welcomeControl.setTitle( getString( "PleaseCloseBrowser", currentLocale ) );
        welcomeControl.setBody( getString( "WelcomeSMCLoggedOut", currentLocale ) );
        messageCenterControl.setType( MessageCenterControl.MSGTYPE_ERROR );
        messageCenterControl.setKey("SMCLoggedOut");
        viewControl.setAllUIDisabled( true );
    }

    // Check for a customized welcome message, which would override what we have already set
    string customMsg = getCustomizedWelcomeMessage( currentLocale );
    if ( customMsg != null ) {
        welcomeControl.setTitle( "" );
        welcomeControl.setBody( customMsg );
    }

    envAdaptor.commitState();
    envAdaptor.destroy();
%>
<wi:Layout id="layout" runat="server" />
<%
}
%>
